"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var xhr_1 = require("./xhr");
var url_1 = require("../helpers/url");
var data_1 = require("../helpers/data");
var headers_1 = require("../helpers/headers");
function dispatchRequest(config) {
    // 处理config
    processConfig(config);
    return xhr_1.default(config).then(function (res) {
        return transformResponseData(res);
    });
}
exports.default = dispatchRequest;
function processConfig(config) {
    // 处理url
    config.url = transformURL(config);
    // 处理headers
    config.headers = transformHeaders(config);
    // 处理data普通对象
    config.data = transformRequestData(config);
    config.headers = headers_1.flattenHeaders(config.headers, config.method);
}
function transformURL(config) {
    var url = config.url, params = config.params, baseURL = config.baseURL;
    if (baseURL && !url_1.isAbsoluteURL(url)) {
        url = url_1.combineURL(baseURL, url);
    }
    return url_1.buildURL(url, params);
}
function transformRequestData(config) {
    return data_1.transformRequest(config.data);
}
function transformHeaders(config) {
    var _a = config.headers, headers = _a === void 0 ? {} : _a, data = config.data;
    return headers_1.processHeaders(headers, data);
}
function transformResponseData(res) {
    res.data = data_1.transformResponse(res.data);
    return res;
}
//# sourceMappingURL=dispatchRequest.js.map